
function initVariables(){
  //global variables
  // svgdoc;
  // kantonText = " ";
  // myDataDisplayTextF;
  // seenText;
  // LK_Nr;
  // landeskarteName;
  // koordinatenTextXmin;
  // koordinatenTextYmin;
  // koordinatenTextXmax;
  // koordinatenTextYmax;
  // fluss_see;
  // lk_info;
  // Kanton_Text;
  // Help_Text;
  // allKantons;
  
  // zoomValueObj;
  // pluginPixHeight;
  // svgRect;
  // pluginPixWidth;
  // svgMainViewport;
  // width;
  // height;
  // evtX;
  // evtY;
  // rectUlXCorner;
  // rectUlYCorner
  // scaleFactor;
  // myYOffset;

  // mapsheetId;
  // mapsheetFrame;
  // mapsheetText;

  // nav_layer_off;
  // tools_off_text;

  // LKsOfKanton;
  // alert(LK_Nr)
}

//initializing values
function initMap(evt){
  // initVariables:
  allWidth = 348428;
  allHeight = 220650; //check with viewBox of SVG!!! 
  xOriginCorner = 485410; //viewBox="485410 -295935 348428 220650" of main Map
  yOriginCorner = -295935;
  pressed = 0;
  myClickStatus = 0;
  
	//svgdoc = document.getElementById("svgdoc");
	svgdoc = evt.target.ownerDocument;
	kantonText = document.getElementById("dataDisplayTextK").firstChild;
	Kanton_Text = document.getElementById("Kanton_Text").firstChild;
	myDataDisplayTextF = document.getElementById("dataDisplayTextF").firstChild;
	seenText = document.getElementById("seenText").firstChild;
	LK_Nr = document.getElementById("LK_Nr").firstChild;
	landeskarteName = document.getElementById("landeskarteName").firstChild;
	koordinatenTextXmin = document.getElementById("koordinatenTextXmin").firstChild;
	koordinatenTextYmin = document.getElementById("koordinatenTextYmin").firstChild;
	koordinatenTextXmax = document.getElementById("koordinatenTextXmax").firstChild;
	koordinatenTextYmax = document.getElementById("koordinatenTextYmax").firstChild;
	fluss_see = document.getElementById("fluss_see");
	lk_info = document.getElementById("lk_info");
	Help_Text = document.getElementById("Help_Text").firstChild;

	zoomVal = 100; //initial zoomFactor
	//overviewObjects
	overviewViewport = document.getElementById("overviewMap");		
	pluginPixWidth = overviewViewport.getAttribute("width");
	pluginPixHeight = overviewViewport.getAttribute("height");
	//reference to draggable rectangle and viewport
	svgRect = document.getElementById("rectForPlace");
	svgMainViewport = document.getElementById("MainMap");
	zoomValueObj = document.getElementById("zoomValueObj");
	zoomValueObj = zoomValueObj.firstChild;
	resetFactors(evt);
	
	mapsheetFrame = document.getElementById("mapsheetFrame");
	mapsheetText = document.getElementById("mapsheetText");
		
	nav_layer_off = document.getElementById("nav_layer_off");
	tools_off_text = document.getElementById("tools_off_text");
	
	LKsOfKanton = document.getElementById("LKsOfKanton");
}

function showHelp(evt, text)  {
	if (evt.type == "mouseover"){	
		Help_Text.data=text; 
	}
	if (evt.type == "mouseout") {
		Help_Text.data='-'; 
	}
		
}
//checkbox handler script for all layers except the 'lk'- layer
function handleCheckBoxClick(evt) {
 		
		var element = evt.currentTarget;
		var text = new String(element.id);
		var layerId = text.replace(/CheckBox/,"");
		var layer = document.getElementById(layerId);
		//var layerVisibility = layer.getAttribute("visibility");
		text = "CheckCross"+layerId;
		var crossElement = document.getElementById(text);
		var currentState = crossElement.getAttribute("visibility");
		if (currentState == "hidden") {
			newState = "visible";
		} else {
			newState = "hidden";
		}
		crossElement.setAttribute("visibility", newState);
		layer.setAttribute("visibility", newState);
		//lk_info.setAttribute("visibility", newState);
}


//checkbox handler for the LK- layer seperatly, it switches on/ off the legend and the layer!
function handleCheckBoxClickLK(evt) {
 		var element = evt.currentTarget;
		var text = new String(element.id);
		var layerId = text.replace(/CheckBox/,"");
		var layer = document.getElementById(layerId);
		//var layerVisibility = layer.getAttribute("visibility");
		text = "CheckCross"+layerId;
		var crossElement = document.getElementById(text);
		var currentState = crossElement.getAttribute("visibility");
		if (currentState == "hidden") {
			newState = "visible";
		} else {
			newState = "hidden";
		}
		crossElement.setAttribute("visibility", newState);
		layer.setAttribute("visibility", newState);
		lk_info.setAttribute("visibility", newState);
}
//shows the attributes of the 'kanton' layer object
function showAttribData(evt,layer,objectId) {
	//it gets the Element of the target object
	var myElObj = document.getElementById(layer+objectId);
	
	//evaluates the third array of the target list contents
	myKant =  eval(layer+objectId)[2];
	
		if (evt.type == "mouseover") {
			myElement = layer+objectId;
			//evaluates the third and first array of the target list contents
			myString = eval(myElement)[2];
			myMapSheets = eval(myKant)[0];
			
			//alert("Lk pro Kanton="+eval(myKant).length);
			
			//to get the LK info. of each Kanton displayed in more than one rows
			
			
			myMapSheets="";
			var i=0;
			var stop = true;
			for(var zeile=0 ; stop ; zeile++) {
			   
			    for(var col=0; col<6; col++, i++) {   
			            
			        if( i == eval(myKant).length ) {
			            stop = false;
			            break;  
			        }
			               
			        myMapSheets = myMapSheets + "  " + eval(myKant)[i];
			    }
			   
			    var text_a = document.createElement('text');
						
				text_a.setAttribute('x', '113');
				text_a.setAttribute('y', new String(380+zeile*20) );
											
				var text = document.createTextNode(myMapSheets);
				text_a.appendChild(text);

				LKsOfKanton.appendChild( text_a );
						
				myMapSheets = "";
					 	
			}
			
			if (!myString) {
				myString = "-";
			}	
			allKantons = document.getElementById('kanton'+myString);
			Kanton_Text.data=myString;	
			allKantons.setAttribute('fill', 'aliceblue');
			allKantons.setAttribute('fill-opacity', '.8');
		}
    if (evt.type == "mouseout") {
			//removes the data
			Kanton_Text.data="-";
			allKantons.setAttribute('fill', 'rgb(255, 239, 213)');
			allKantons.setAttribute('fill-opacity', '.7');	
			//delete LKsOfKanton contents -> Text
			while( (fC = LKsOfKanton.firstChild) != null  ) {
			  LKsOfKanton.removeChild(fC);    
			}
     }
}

//shows attributes of the 'fluss' layers objects
function showAttribDataF(evt,layer,objectId) {
	if (evt.type == "mouseover") {
			myElement = layer+objectId;
			myString = eval(myElement)[0];
			if (!myString) {
				myString = "-";
			}	
			myDataDisplayTextF.data=myString;		
		}
		if (evt.type == "mouseout") {
			myDataDisplayTextF.data="-";
		}
	
}
//shows attributes of the 'see' layer objects
function showSeenDataF(evt,seenId) {
	if (evt.type == "mouseover") {
			myElement = "seen"+seenId;
			myString = eval(myElement)[0];
			if (!myString) {
				myString = "-";
			}	
			seenText.data=myString;		
		}
		if (evt.type == "mouseout") {
			seenText.data="-";
		}
	
}
//show Attribute of LK25 and highlight the current LK25- sheet
function showAttribDataLK(evt,LK,LKId) {
	var myElObj = document.getElementById(LK+LKId);
	myElement = LK+LKId;	
	myString = eval(myElement);
		// alert(evt.type+"\n"+kantonText);
	if (evt.type == "mouseover") {
			var nachfuehrId = myString[2];
			// alert(nachfuehrId);
			var nachfuehrEl = document.getElementById(nachfuehrId);
			
			var geplantePublId = myString[4];
			if (geplantePublId == "-"){geplantePublId = "keinePubl";}
			var geplantePublEl = document.getElementById(geplantePublId);
			geplantePublEl.setAttribute('fill', 'rgb(195, 10, 70)');
												
			if (!myString) {myString = "-";}
			
			nachfuehrEl.setAttribute('fill', 'rgb(195, 10, 70)');
							
			LK_Nr.data=myString[0];
			//LK_Nr.data=myElement);
			landeskarteName.data=myString[1];
			kantonText.data=myString[3];
			
			myElObj.setAttribute('fill', 'rgb(255, 20, 30)');
			myElObj.setAttribute('fill-opacity', '.7');
			myRect = myElObj.getBBox();
			koordinatenTextXmin.data="X- Min:  "+(myRect.x);
			koordinatenTextYmin.data="Y- Min:  "+((myRect.y+myRect.height)*-1);   //+(myRect.y*(-1))
			koordinatenTextXmax.data="X- Max: "+(myRect.x+myRect.width);
			koordinatenTextYmax.data="Y- Max: "+(myRect.y*(-1));    //+((myRect.y+myRect.height)*-1)
			Help_Text.data='Klicke auf Landeskarte, um Ausschnitt zu vergroessern.'; 
	 	}
		if (evt.type == "mouseout") {
			myElObj.setAttribute('fill', 'rgb(150,150,150) ');
			myElObj.setAttribute('fill-opacity', '.1');
			if (myClickStatus == 0){
				LK_Nr.data="-";
				landeskarteName.data="";
				kantonText.data="-";
				
				koordinatenTextXmin.data="-";
				koordinatenTextYmin.data="-";
				koordinatenTextXmax.data="-";
				koordinatenTextYmax.data="-";
			
				var nachfuehrId = myString[2];
				var nachfuehrEl = document.getElementById(nachfuehrId);	
				nachfuehrEl.setAttribute('fill', 'rgb( 47, 79, 79)');
			
			
				var geplantePublId = myString[4];
					if (geplantePublId == "-"){geplantePublId = "keinePubl";}
				var geplantePublEl = document.getElementById(geplantePublId);
				geplantePublEl.setAttribute('fill', 'rgb( 47, 79, 79)');
			}
			Help_Text.data='-'; 
		
		}
		
}

function resetFactors(evt) {
	myRatio = 1024/768;
	if ((window.innerWidth/window.innerHeight) > myRatio) {
		scaleFactor = 768 / window.innerHeight;
	}
	else {
		scaleFactor = 1024 / window.innerWidth;		
	}
}

//magnifier glass mouse-over effects
function magnify(evt,scaleFact,inOrOut) {
	if (inOrOut == "in") {
		if (zoomVal < 1000) {
			//statusChange("click to zoom in");
			Help_Text.data='Click den Button, um zuvergroessern.'; 
			scaleObject(evt,scaleFact);
		}
		else {
			//statusChange("maximum zoom factor reached! cannot zoom in any more!");
			Help_Text.data='Maximale Zoomfaktor ist erreicht.'; 			
		}
	}
	if (inOrOut == "out") {
		if (zoomVal > 100) {
			//statusChange("click to zoom out");
			Help_Text.data='Click den Button, um zu verkleinern.'; 
			scaleObject(evt,scaleFact);
		}
		else {
		//	statusChange("minimum zoom factor reached! cannot zoom out any more!");	
			Help_Text.data='Minimale Zoomfaktor ist erreicht.'; 		
		}		
	}
	if (scaleFact == 1) {
			//statusChange("map ready");	
			Help_Text.data='Karte ist fertig!'; 	
			scaleObject(evt,scaleFact);
	}	
}

//scale any object that has a transform-value
function scaleObject(evt,factor) {
        //reference to the currently selected object
        var element = evt.currentTarget;
        // alert(evt.currentTarget.id);

        //query old transform value (we need the translation value)
        var curTransform = element.getAttribute("transform");
        curTransform = new String(curTransform); //Wert in ein String umwandeln
        //no fear from Regular expressions ... just copy it, I copied it either ...
        var translateRegExp=/translate\(([-+]?\d+)(\s*[\s,]\s*)([-+]?\d+)\)\s*/;

        //This part extracts the translation-value from the whole transform-string
        if (curTransform.length != 0)
        {
          var result = curTransform.match(translateRegExp);
          if (result == null || result.index == -1)
          {
             oldTranslateX = 0;
             oldTranslateY = 0;
          }
          else
          {
             oldTranslateX = result[1];
             oldTranslateY = result[3];
          }
          //concatenate the string again, add scale-factor
          var newtransform = "translate(" + oldTranslateX + " " + oldTranslateY + ") " + "scale(" + factor + ")";
        }
        //set transform-factor
        element.setAttribute('transform', newtransform);
}


function beginPan(evt) {
	pressed = 1;
	// width = parseFloat(svgRect.getAttribute("width"));
	// height = parseFloat(svgRect.getAttribute("height"));
	width = parseFloat(svgRect.getBBox().width);
	height = parseFloat(svgRect.getBBox().height);
	evtX = parseFloat(evt.clientX) * scaleFactor;
	evtY = parseFloat(evt.clientY) * scaleFactor;
	// rectUlXCorner = parseFloat(svgRect.getAttribute("x"));
	// rectUlYCorner = parseFloat(svgRect.getAttribute("y"));	
	rectUlXCorner = parseFloat(svgRect.getBBox().x);
	rectUlYCorner = parseFloat(svgRect.getBBox().y);	
}

function doPan(evt) {
	if (pressed == 1) {
		newEvtX = parseFloat(evt.pageX) * scaleFactor; //scaleFactor is because of resizable interface
		newEvtY = parseFloat(evt.pageY) * scaleFactor;
		toMoveX = rectUlXCorner + (newEvtX - evtX) * allWidth / pluginPixWidth;
		toMoveY = rectUlYCorner + (newEvtY - evtY) * allHeight / pluginPixHeight;
		
		//restrict to borders of overviewmap
		if (toMoveX < xOriginCorner) {
			svgRect.setAttribute("x",xOriginCorner);
		}
		else if ((toMoveX + width) > (xOriginCorner + allWidth)) {
			svgRect.setAttribute("x",xOriginCorner + allWidth - width);				
		}
		else {
			svgRect.setAttribute("x",toMoveX);			
		}
		if (toMoveY < yOriginCorner) {
			svgRect.setAttribute("y",yOriginCorner);
		}
		else if ((toMoveY + height) > (yOriginCorner + allHeight)) {
			svgRect.setAttribute("y",yOriginCorner + allHeight - height);
		}				
		else {
			svgRect.setAttribute("y",toMoveY);
		}
		
		evtX = newEvtX;
		evtY = newEvtY;
		// rectUlXCorner = parseFloat(svgRect.getAttribute("x"));
		// rectUlYCorner = parseFloat(svgRect.getAttribute("y"));
		rectUlXCorner = parseFloat(svgRect.getBBox().x);
		rectUlYCorner = parseFloat(svgRect.getBBox().y);	
	}	
}

function endPan() {
	//statusChange("panning map - please be patient ...");
	Help_Text.data='Etwas Geduld bitte!'; 
	pressed = 0;
	//set viewport of main map
	// xulcorner = parseFloat(svgRect.getAttribute("x"));
	// yulcorner = parseFloat(svgRect.getAttribute("y"));
	xulcorner = parseFloat(svgRect.getBBox().x);
	yulcorner = parseFloat(svgRect.getBBox().y);
	// width = parseFloat(svgRect.getAttribute("width"));
	// height = parseFloat(svgRect.getAttribute("height"));
	width = parseFloat(svgRect.getBBox().width);
	height = parseFloat(svgRect.getBBox().height);
	newViewport = xulcorner + " " + yulcorner + " " + width + " " + height;
	svgMainViewport.setAttribute("viewBox",newViewport);
	//statusChange("map ready ...");
	Help_Text.data='Karte ist fertig!'; 
}


function zoomIt(inOrOut) {
	if (inOrOut == "in") {
		if (zoomVal < 1000) {
			//statusChange("click to zoom in");
			Help_Text.data='Click Button, um zu vergroessern.'; 
			zoomVal = zoomVal + 100;
			zoomItReally();
		}
		else {
		//	statusChange("maximum zoom factor reached! cannot zoom in any more!");
			Help_Text.data='Maximale Zoomfaktor ist erreicht.'; 
		}
	}
	if (inOrOut == "out") {
		if (zoomVal > 100) {
			//statusChange("click to zoom out");
			Help_Text.data='Click Button, um zu verkleinern.'; 
			zoomVal = zoomVal - 100;
			zoomItReally();
		}
		else {
		//	statusChange("minimum zoom factor reached! cannot zoom out any more!");			
			Help_Text.data='Minimaler Zoomfaktor ist erreicht.'; 
		}		
	}
}

function zoomItReally() {
	//statusChange("panning map - please be patient ...");
	Help_Text.data='Etwas Geduld bitte!'; 

	//get values from draggable rectangle
  BBox = svgRect.getBBox();
	xulcorner = parseFloat(BBox.x);
	yulcorner = parseFloat(BBox.y);
	width = parseFloat(BBox.width);
	height = parseFloat(BBox.height);
  
  // alert("x:\t"+xulcorner+"\ny:\t"+yulcorner+"\nwidth:\t"+width+"\nheight:\t"+height);
	
	//calcs
	xcenter = xulcorner + width / 2;
	ycenter = yulcorner + height / 2;
	xnulcorner = xcenter - allWidth / 2 * (100/zoomVal);
	ynulcorner = ycenter - allHeight / 2 * (100/zoomVal);
	nWidth = allWidth * (100/zoomVal);
	nHeight = allHeight * (100/zoomVal);

	if (zoomVal == 100) {
		xnulcorner = xOriginCorner;
		ynulcorner = yOriginCorner;
	}		
	//set values of draggable rectangle
	svgRect.setAttribute("x",xnulcorner);
	svgRect.setAttribute("y",ynulcorner);
	svgRect.setAttribute("width",nWidth);
	svgRect.setAttribute("height",nHeight);
	
	//set viewport of main map
	newViewport = xnulcorner + " " + ynulcorner + " " + nWidth + " " + nHeight;
	svgMainViewport.setAttribute("viewBox",newViewport);
	zoomValueObj.data=zoomVal+'%';
	//statusChange("map ready ...");
	Help_Text.data='Karte ist fertig!'; 
}

function showMapsheet(evt){
  myClickStatus = 1;
	var mapsheet = evt.target;
	var mapsheetId = mapsheet.getAttribute('id');
	var mapsheetNr = eval(mapsheetId)[0];
 	
/*	node = document.createElement('image');
	node.setAttribute("xlink:href", "./map_sheets/"+mapsheetNr+".jpg");
	// node.setAttribute('href', "./map_sheets/"+mapsheetNr+".jpg");
	node.setAttribute('x', '380');
	node.setAttribute('y','110');
	node.setAttribute('width', '500');
	node.setAttribute('height', '365');
	node.setAttribute('id', mapsheetNr);
  
  // raster_images.children[1].setAttribute('visibility','visible');*/
	
	var map = document.getElementById('mapPreview');
  map.setAttribute("xlink:href", "./map_sheets/"+mapsheetNr+".jpg");
  map.setAttribute('visibility','visible');
	mapsheetFrame.setAttribute('visibility','visible');
	mapsheetText.setAttribute('visibility','visible');
  nav_layer_off.setAttribute('visibility','visible');
	tools_off_text.setAttribute('visibility','visible');
}
	
function switschMapsheetOff(evt){
	var map = document.getElementById('mapPreview');
  map.setAttribute("xlink:href", "");
  map.setAttribute('visibility','hidden');
	myClickStatus = 0;
	var mapsheet = evt.target;
	Help_Text.data='- '; 
	mapsheetFrame.setAttribute('visibility','hidden');
	mapsheetText.setAttribute('visibility','hidden');
	nav_layer_off.setAttribute('visibility','hidden');
	tools_off_text.setAttribute('visibility','hidden');
	// alle Jahreszahlen beim Nachfhrungsstand schwarz machen:
	Gruppe = document.getElementById("nachfuehrungsstand").firstChild
	for (i=1984;i<=2020; i++){
		element = document.getElementById(i);
		if (element != null){
			element.setAttribute('fill', 'rgb( 47, 79, 79)');
		}
	}
}
